<template>
    <div class="clock-card is-card">
        <i class="description">Game Clock</i>
        <table>
            <tr>
                <td colspan="2">
                    <input
                        v-model.lazy="formattedTime"
                        class="hidden-input"
                        @focus="gameClock.running && toggleClock()"
                    />
                </td>

                <td class="clicky" @click="toggleClock">
                    <i
                        :class="`fas fa-${
                            gameClock.running ? 'pause' : 'play'
                        }`"
                    ></i>
                </td>
                <td class="clicky" @click="resetClock">
                    <i class="fas fa-redo"></i>
                </td>
            </tr>
            <tr>
                <td
                    v-for="n in 4"
                    :key="n"
                    :class="`${gameClock.quarter === n && 'active'} clicky`"
                    @click="setQuarter(n)"
                >
                    Q{{ n }}
                </td>
            </tr>
        </table>
    </div>
</template>

<script lang="ts">
import Vue from "vue";
import state from "~/state";

export default Vue.extend({
    data() {
        return {
            countdown: -1,
            quarterTimes: [720, 720, 720, 720],
        };
    },
    computed: {
        formattedTime: {
            get(): string {
                return state.formatTime(state.gameClock.time);
            },
            set(value: string) {
                const [min, sec] = value.trim().split(":");
                state.gameClock.time = Number(min) * 60 + Number(sec);
            },
        },
        gameClock() {
            return state.gameClock;
        },
    },
    methods: {
        setQuarter(n: QuarterT) {
            this.quarterTimes[state.gameClock.quarter - 1] =
                state.gameClock.time;
            state.gameClock.quarter = n;
            if (state.gameClock.running) {
                this.toggleClock();
            }
            this.formattedTime = state.formatTime(
                this.quarterTimes[state.gameClock.quarter - 1]
            );
        },
        resetClock() {
            if (state.gameClock.running) {
                this.toggleClock();
            }
            this.formattedTime = "12:00";
        },
        toggleClock() {
            if (state.gameClock.running) {
                clearInterval(this.countdown);
            } else {
                state.gameClock.time--;
                this.countdown = (setInterval(() => {
                    if (state.gameClock.time === 0) {
                        clearInterval(this.countdown);
                    } else {
                        state.gameClock.time--;
                    }
                }, 1000) as unknown) as number;
            }

            state.gameClock.running = !state.gameClock.running;
        },
    },
});
</script>
